Package com.fasterxml.jackson.core.base

# Class GeneratorBase

java.lang.Object
com.fasterxml.jackson.core.JsonGenerator
com.fasterxml.jackson.core.base.GeneratorBase

All Implemented Interfaces:
  `Versioned`, `Closeable`, `Flushable`, `AutoCloseable`

Direct Known Subclasses:
  `JsonGeneratorImpl`

public abstract class GeneratorBase extends JsonGenerator
This base class implements part of API that a JSON generator exposes to applications, adds shared internal methods that sub-classes can use and adds some abstract methods sub-classes must implement.

## Nested Class Summary

## Nested classes/interfaces inherited from class com.fasterxml.jackson.core.JsonGenerator

`JsonGenerator.Feature`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected boolean`
`_cfgNumbersAsStrings`
Flag set to indicate that implicit conversion from number to JSON String is needed (as per `JsonWriteFeature.WRITE_NUMBERS_AS_STRINGS`).
`protected boolean`
`_closed`
Flag that indicates whether generator is closed or not.
`protected int`
`_features`
Bit flag composed of bits that indicate which `JsonGenerator.Feature`s are enabled.
`protected final IOContext`
`_ioContext`
`protected ObjectCodec`
`_objectCodec`
`protected JsonWriteContext`
`_writeContext`
Object that keeps track of the current contextual state of the generator.
`protected static final int`
`DERIVED_FEATURES_MASK`
Set of feature masks related to features that need updates of other local configuration or state.
`protected static final int`
`MAX_BIG_DECIMAL_SCALE`
This value is the limit of scale allowed for serializing `BigDecimal` in "plain" (non-engineering) notation; intent is to prevent asymmetric attack whereupon simple eng-notation with big scale is used to generate huge "plain" serialization.
`static final int`
`SURR1_FIRST`
`static final int`
`SURR1_LAST`
`static final int`
`SURR2_FIRST`
`static final int`
`SURR2_LAST`
`protected static final String`
`WRITE_BINARY`
`protected static final String`
`WRITE_BOOLEAN`
`protected static final String`
`WRITE_NULL`
`protected static final String`
`WRITE_NUMBER`
`protected static final String`
`WRITE_RAW`
`protected static final String`
`WRITE_STRING`

### Fields inherited from class com.fasterxml.jackson.core.JsonGenerator

`_cfgPrettyPrinter, DEFAULT_BINARY_WRITE_CAPABILITIES, DEFAULT_TEXTUAL_WRITE_CAPABILITIES, DEFAULT_WRITE_CAPABILITIES`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`GeneratorBase(int features, ObjectCodec codec)`
Deprecated.
`protected`
`GeneratorBase(int features, ObjectCodec codec, IOContext ioContext)`
`protected`
`GeneratorBase(int features, ObjectCodec codec, IOContext ioContext, JsonWriteContext jsonWriteContext)`
`protected`
`GeneratorBase(int features, ObjectCodec codec, JsonWriteContext ctxt)`
Deprecated.

## Method Summary

Modifier and Type
Method
Description
`protected String`
`_asString(BigDecimal value)`
Helper method used to serialize a `BigDecimal` as a String, for serialization, taking into account configuration settings
`protected void`
`_checkRangeBoundsForByteArray(byte[] data, int offset, int len)`
`protected void`
`_checkRangeBoundsForCharArray(char[] data, int offset, int len)`
`protected void`
`_checkRangeBoundsForString(String data, int offset, int len)`
`protected void`
`_checkStdFeatureChanges(int newFeatureFlags, int changedFeatures)`
Helper method called to verify changes to standard features.
`protected PrettyPrinter`
`_constructDefaultPrettyPrinter()`
Overridable factory method called to instantiate an appropriate `PrettyPrinter` for case of "just use the default one", when `useDefaultPrettyPrinter()` is called.
`protected final int`
`_decodeSurrogate(int surr1, int surr2)`
`protected abstract void`
`_releaseBuffers()`
Method called to release any buffers generator may be holding, once generator is being closed.
`protected abstract void`
`_verifyValueWrite(String typeMsg)`
Method called before trying to write a value (scalar or structured), to verify that this is legal in current output state, as well as to output separators if and as necessary.
`void`
`close()`
Method called to close this generator, so that no more content can be written.
`JsonGenerator`
`disable(JsonGenerator.Feature f)`
Method for disabling specified feature (check `JsonGenerator.Feature` for list of features)
`JsonGenerator`
`enable(JsonGenerator.Feature f)`
Method for enabling specified generator feature: check `JsonGenerator.Feature` for list of available features.
`abstract void`
`flush()`
Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.
`ObjectCodec`
`getCodec()`
Method for accessing the object used for writing Java object as JSON content (using method `JsonGenerator.writeObject(java.lang.Object)`).
`Object`
`getCurrentValue()`
Alias for `JsonGenerator.currentValue()`, to be deprecated in later Jackson 2.x versions (and removed from Jackson 3.0).
`int`
`getFeatureMask()`
Bulk access method for getting state of all standard (non-dataformat-specific) `JsonGenerator.Feature`s.
`JsonStreamContext`
`getOutputContext()`
Note: type was co-variant until Jackson 2.7; reverted back to base type in 2.8 to allow for overriding by subtypes that use custom context type.
`boolean`
`isClosed()`
Method that can be called to determine whether this generator is closed or not.
`final boolean`
`isEnabled(JsonGenerator.Feature f)`
Method for checking whether given feature is enabled.
`JsonGenerator`
`overrideStdFeatures(int values, int mask)`
Bulk set method for (re)setting states of features specified by `mask`.
`JsonGenerator`
`setCodec(ObjectCodec oc)`
Method that can be called to set or reset the object to use for writing Java objects as JsonContent (using method `JsonGenerator.writeObject(java.lang.Object)`).
`void`
`setCurrentValue(Object v)`
Alias for `JsonGenerator.assignCurrentValue(java.lang.Object)`, to be deprecated in later Jackson 2.x versions (and removed from Jackson 3.0).
`JsonGenerator`
`setFeatureMask(int newMask)`
Deprecated.
`JsonGenerator`
`useDefaultPrettyPrinter()`
Convenience method for enabling pretty-printing using the default pretty printer (`DefaultPrettyPrinter`).
`Version`
`version()`
Implemented with standard version number detection algorithm, typically using a simple generated class, with information extracted from Maven project file during build.
`int`
`writeBinary(Base64Variant b64variant, InputStream data, int dataLength)`
Method similar to `JsonGenerator.writeBinary(Base64Variant,byte[],int,int)`, but where input is provided through a stream, allowing for incremental writes without holding the whole input in memory.
`void`
`writeFieldName(SerializableString name)`
Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.
`void`
`writeObject(Object value)`
Older alias for `JsonGenerator.writePOJO(Object)`
`void`
`writeRawValue(char[] text, int offset, int len)`
`void`
`writeRawValue(SerializableString text)`
Method similar to `JsonGenerator.writeRawValue(String)`, but potentially more efficient as it may be able to use pre-encoded content (similar to `JsonGenerator.writeRaw(SerializableString)`.
`void`
`writeRawValue(String text)`
Method that will force generator to copy input text verbatim without any modifications, but assuming it must constitute a single legal JSON value (number, string, boolean, null, Array or List).
`void`
`writeRawValue(String text, int offset, int len)`
`void`
`writeStartObject(Object forValue)`
Method for writing starting marker of an Object value to represent the given Java Object value.
`void`
`writeString(SerializableString text)`
Method similar to `JsonGenerator.writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.
`void`
`writeTree(TreeNode rootNode)`
Method for writing given JSON tree (expressed as a tree where given JsonNode is the root) using this generator.

### Methods inherited from class com.fasterxml.jackson.core.JsonGenerator

`_copyCurrentContents, _copyCurrentFloatValue, _copyCurrentFloatValueExact, _copyCurrentIntValue, _copyCurrentStringValue, _reportError, _reportUnsupportedOperation, _throwInternal, _verifyOffsets, _writeSimpleObject, assignCurrentValue, canOmitFields, canUseSchema, canWriteBinaryNatively, canWriteFormattedNumbers, canWriteObjectId, canWriteTypeId, configure, copyCurrentEvent, copyCurrentEventExact, copyCurrentStructure, currentValue, getCharacterEscapes, getFormatFeatures, getHighestEscapedChar, getOutputBuffered, getOutputTarget, getPrettyPrinter, getSchema, getWriteCapabilities, isEnabled, overrideFormatFeatures, setCharacterEscapes, setHighestNonEscapedChar, setPrettyPrinter, setRootValueSeparator, setSchema, streamWriteConstraints, writeArray, writeArray, writeArray, writeArray, writeArrayFieldStart, writeBinary, writeBinary, writeBinary, writeBinary, writeBinaryField, writeBoolean, writeBooleanField, writeEmbeddedObject, writeEndArray, writeEndObject, writeFieldId, writeFieldName, writeNull, writeNullField, writeNumber, writeNumber, writeNumber, writeNumber, writeNumber, writeNumber, writeNumber, writeNumber, writeNumber, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeObjectField, writeObjectFieldStart, writeObjectId, writeObjectRef, writeOmittedField, writePOJO, writePOJOField, writeRaw, writeRaw, writeRaw, writeRaw, writeRaw, writeRawUTF8String, writeStartArray, writeStartArray, writeStartArray, writeStartArray, writeStartObject, writeStartObject, writeString, writeString, writeString, writeStringField, writeTypeId, writeTypePrefix, writeTypeSuffix, writeUTF8String`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### SURR1_FIRST

public static final int SURR1_FIRST

See Also:
  - Constant Field Values

### SURR1_LAST

public static final int SURR1_LAST

See Also:
  - Constant Field Values

### SURR2_FIRST

public static final int SURR2_FIRST

See Also:
  - Constant Field Values

### SURR2_LAST

public static final int SURR2_LAST

See Also:
  - Constant Field Values

### DERIVED_FEATURES_MASK

protected static final int DERIVED_FEATURES_MASK
Set of feature masks related to features that need updates of other local configuration or state.

Since:
  2.5

### WRITE_BINARY

protected static final String WRITE_BINARY

See Also:
  - Constant Field Values

### WRITE_BOOLEAN

protected static final String WRITE_BOOLEAN

See Also:
  - Constant Field Values

### WRITE_NULL

protected static final String WRITE_NULL

See Also:
  - Constant Field Values

### WRITE_NUMBER

protected static final String WRITE_NUMBER

See Also:
  - Constant Field Values

### WRITE_RAW

protected static final String WRITE_RAW

See Also:
  - Constant Field Values

### WRITE_STRING

protected static final String WRITE_STRING

See Also:
  - Constant Field Values

### MAX_BIG_DECIMAL_SCALE

protected static final int MAX_BIG_DECIMAL_SCALE
This value is the limit of scale allowed for serializing `BigDecimal` in "plain" (non-engineering) notation; intent is to prevent asymmetric attack whereupon simple eng-notation with big scale is used to generate huge "plain" serialization. See [core#315] for details.

Since:
  2.7.7
See Also:
  - Constant Field Values

### _objectCodec

protected ObjectCodec _objectCodec

### _features

protected int _features
Bit flag composed of bits that indicate which `JsonGenerator.Feature`s are enabled.

### _ioContext

protected final IOContext _ioContext

### _cfgNumbersAsStrings

protected boolean _cfgNumbersAsStrings
Flag set to indicate that implicit conversion from number to JSON String is needed (as per `JsonWriteFeature.WRITE_NUMBERS_AS_STRINGS`).

### _writeContext

protected JsonWriteContext _writeContext
Object that keeps track of the current contextual state of the generator.

### _closed

protected boolean _closed
Flag that indicates whether generator is closed or not. Gets set when it is closed by an explicit call (`close()`).

## Constructor Details

### GeneratorBase

@Deprecated protected GeneratorBase(int features, ObjectCodec codec)
Deprecated.

### GeneratorBase

protected GeneratorBase(int features, ObjectCodec codec, IOContext ioContext)

### GeneratorBase

@Deprecated protected GeneratorBase(int features, ObjectCodec codec, JsonWriteContext ctxt)
Deprecated.

### GeneratorBase

protected GeneratorBase(int features, ObjectCodec codec, IOContext ioContext, JsonWriteContext jsonWriteContext)

## Method Details

### version

public Version version()
Implemented with standard version number detection algorithm, typically using a simple generated class, with information extracted from Maven project file during build.

Specified by:
  `version` in interface `Versioned`
Specified by:
  `version` in class `JsonGenerator`
Returns:
  Version number of the generator (version of the jar that contains generator implementation class)

### getCurrentValue

public Object getCurrentValue()
Description copied from class: `JsonGenerator`
Alias for `JsonGenerator.currentValue()`, to be deprecated in later Jackson 2.x versions (and removed from Jackson 3.0).

Overrides:
  `getCurrentValue` in class `JsonGenerator`
Returns:
  Location of the last processed input unit (byte or character)

### setCurrentValue

public void setCurrentValue(Object v)
Description copied from class: `JsonGenerator`
Alias for `JsonGenerator.assignCurrentValue(java.lang.Object)`, to be deprecated in later Jackson 2.x versions (and removed from Jackson 3.0).

Overrides:
  `setCurrentValue` in class `JsonGenerator`
Parameters:
  `v` - Current value to assign for the current context of this generator

### isEnabled

public final boolean isEnabled(JsonGenerator.Feature f)
Description copied from class: `JsonGenerator`
Method for checking whether given feature is enabled. Check `JsonGenerator.Feature` for list of available features.

Specified by:
  `isEnabled` in class `JsonGenerator`
Parameters:
  `f` - Feature to check
Returns:
  True if specified feature is enabled; false if not

### getFeatureMask

public int getFeatureMask()
Description copied from class: `JsonGenerator`
Bulk access method for getting state of all standard (non-dataformat-specific) `JsonGenerator.Feature`s.

Specified by:
  `getFeatureMask` in class `JsonGenerator`
Returns:
  Bit mask that defines current states of all standard `JsonGenerator.Feature`s.

### enable

public JsonGenerator enable(JsonGenerator.Feature f)
Description copied from class: `JsonGenerator`
Method for enabling specified generator feature: check `JsonGenerator.Feature` for list of available features.

Specified by:
  `enable` in class `JsonGenerator`
Parameters:
  `f` - Feature to enable
Returns:
  This generator, to allow call chaining

### disable

public JsonGenerator disable(JsonGenerator.Feature f)
Description copied from class: `JsonGenerator`
Method for disabling specified feature (check `JsonGenerator.Feature` for list of features)

Specified by:
  `disable` in class `JsonGenerator`
Parameters:
  `f` - Feature to disable
Returns:
  This generator, to allow call chaining

### setFeatureMask

@Deprecated public JsonGenerator setFeatureMask(int newMask)
Deprecated.
Description copied from class: `JsonGenerator`
Bulk set method for (re)setting states of all standard `JsonGenerator.Feature`s

Specified by:
  `setFeatureMask` in class `JsonGenerator`
Parameters:
  `newMask` - Bitmask that defines which `JsonGenerator.Feature`s are enabled and which disabled
Returns:
  This generator, to allow call chaining

### overrideStdFeatures

public JsonGenerator overrideStdFeatures(int values, int mask)
Description copied from class: `JsonGenerator`
Bulk set method for (re)setting states of features specified by `mask`. Functionally equivalent to `int oldState = getFeatureMask(); int newState = (oldState & ~mask) | (values & mask); setFeatureMask(newState);` but preferred as this lets caller more efficiently specify actual changes made.

Overrides:
  `overrideStdFeatures` in class `JsonGenerator`
Parameters:
  `values` - Bit mask of set/clear state for features to change
  `mask` - Bit mask of features to change
Returns:
  This generator, to allow call chaining

### _checkStdFeatureChanges

protected void _checkStdFeatureChanges(int newFeatureFlags, int changedFeatures)
Helper method called to verify changes to standard features.

Parameters:
  `newFeatureFlags` - Bitflag of standard features after they were changed
  `changedFeatures` - Bitflag of standard features for which setting did change
Since:
  2.7

### useDefaultPrettyPrinter

public JsonGenerator useDefaultPrettyPrinter()
Description copied from class: `JsonGenerator`
Convenience method for enabling pretty-printing using the default pretty printer (`DefaultPrettyPrinter`).

Specified by:
  `useDefaultPrettyPrinter` in class `JsonGenerator`
Returns:
  This generator, to allow call chaining

### setCodec

public JsonGenerator setCodec(ObjectCodec oc)
Description copied from class: `JsonGenerator`
Method that can be called to set or reset the object to use for writing Java objects as JsonContent (using method `JsonGenerator.writeObject(java.lang.Object)`).

Specified by:
  `setCodec` in class `JsonGenerator`
Parameters:
  `oc` - Codec to assign, if any; `null` if none
Returns:
  This generator, to allow call chaining

### getCodec

public ObjectCodec getCodec()
Description copied from class: `JsonGenerator`
Method for accessing the object used for writing Java object as JSON content (using method `JsonGenerator.writeObject(java.lang.Object)`).

Specified by:
  `getCodec` in class `JsonGenerator`
Returns:
  Codec assigned to this generator, if any; `null` if none

### getOutputContext

public JsonStreamContext getOutputContext()
Note: type was co-variant until Jackson 2.7; reverted back to base type in 2.8 to allow for overriding by subtypes that use custom context type.

Specified by:
  `getOutputContext` in class `JsonGenerator`
Returns:
  Stream output context (`JsonStreamContext`) associated with this generator

### writeStartObject

public void writeStartObject(Object forValue) throws IOException
Description copied from class: `JsonGenerator`
Method for writing starting marker of an Object value to represent the given Java Object value. Argument is offered as metadata, but more importantly it should be assigned as the "current value" for the Object content that gets constructed and initialized.

Object values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

Overrides:
  `writeStartObject` in class `JsonGenerator`
Parameters:
  `forValue` - "Current value" to assign for the Object context being created
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeFieldName

public void writeFieldName(SerializableString name) throws IOException
Description copied from class: `JsonGenerator`
Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.

Default implementation simple uses unprocessed name container in serialized String; implementations are strongly encouraged to make use of more efficient methods argument object has.

Specified by:
  `writeFieldName` in class `JsonGenerator`
Parameters:
  `name` - Field name to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeString

public void writeString(SerializableString text) throws IOException
Description copied from class: `JsonGenerator`
Method similar to `JsonGenerator.writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.

Default implementation just calls `JsonGenerator.writeString(String)`; sub-classes should override it with more efficient implementation if possible.

Specified by:
  `writeString` in class `JsonGenerator`
Parameters:
  `text` - Pre-encoded String value to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeRawValue

public void writeRawValue(String text) throws IOException
Description copied from class: `JsonGenerator`
Method that will force generator to copy input text verbatim without any modifications, but assuming it must constitute a single legal JSON value (number, string, boolean, null, Array or List). Assuming this, proper separators are added if and as needed (comma or colon), and generator state updated to reflect this.

Specified by:
  `writeRawValue` in class `JsonGenerator`
Parameters:
  `text` - Textual contents to included in output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeRawValue

public void writeRawValue(String text, int offset, int len) throws IOException

Specified by:
  `writeRawValue` in class `JsonGenerator`
Throws:
  `IOException`

### writeRawValue

public void writeRawValue(char[] text, int offset, int len) throws IOException

Specified by:
  `writeRawValue` in class `JsonGenerator`
Throws:
  `IOException`

### writeRawValue

public void writeRawValue(SerializableString text) throws IOException
Description copied from class: `JsonGenerator`
Method similar to `JsonGenerator.writeRawValue(String)`, but potentially more efficient as it may be able to use pre-encoded content (similar to `JsonGenerator.writeRaw(SerializableString)`.

Overrides:
  `writeRawValue` in class `JsonGenerator`
Parameters:
  `text` - Pre-encoded textual contents to included in output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeBinary

public int writeBinary(Base64Variant b64variant, InputStream data, int dataLength) throws IOException
Description copied from class: `JsonGenerator`
Method similar to `JsonGenerator.writeBinary(Base64Variant,byte[],int,int)`, but where input is provided through a stream, allowing for incremental writes without holding the whole input in memory.

Specified by:
  `writeBinary` in class `JsonGenerator`
Parameters:
  `b64variant` - Base64 variant to use
  `data` - InputStream to use for reading binary data to write. Will not be closed after successful write operation
  `dataLength` - (optional) number of bytes that will be available; or -1 to be indicate it is not known. If a positive length is given, `data` MUST provide at least that many bytes: if not, an exception will be thrown. Note that implementations need not support cases where length is not known in advance; this depends on underlying data format: JSON output does NOT require length, other formats may.
Returns:
  Number of bytes read from `data` and written as binary payload
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeObject

public void writeObject(Object value) throws IOException
Description copied from class: `JsonGenerator`
Older alias for `JsonGenerator.writePOJO(Object)`

Specified by:
  `writeObject` in class `JsonGenerator`
Parameters:
  `value` - Java value (usually POJO) to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeTree

public void writeTree(TreeNode rootNode) throws IOException
Description copied from class: `JsonGenerator`
Method for writing given JSON tree (expressed as a tree where given JsonNode is the root) using this generator. This will generally just call `JsonGenerator.writeObject(java.lang.Object)` with given node, but is added for convenience and to make code more explicit in cases where it deals specifically with trees.

Specified by:
  `writeTree` in class `JsonGenerator`
Parameters:
  `rootNode` - `TreeNode` to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### flush

public abstract void flush() throws IOException
Description copied from class: `JsonGenerator`
Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.

Specified by:
  `flush` in interface `Flushable`
Specified by:
  `flush` in class `JsonGenerator`
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### close

public void close() throws IOException
Description copied from class: `JsonGenerator`
Method called to close this generator, so that no more content can be written.

Whether the underlying target (stream, writer) gets closed depends on whether this generator either manages the target (i.e. is the only one with access to the target -- case if caller passes a reference to the resource such as File, but not stream); or has feature `JsonGenerator.Feature.AUTO_CLOSE_TARGET` enabled. If either of above is true, the target is also closed. Otherwise (not managing, feature not enabled), target is not closed.

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in class `JsonGenerator`
Throws:
  `IOException` - if there is either an underlying I/O problem

### isClosed

public boolean isClosed()
Description copied from class: `JsonGenerator`
Method that can be called to determine whether this generator is closed or not. If it is closed, no more output can be done.

Specified by:
  `isClosed` in class `JsonGenerator`
Returns:
  `True` if this generator instance has been closed

### _releaseBuffers

protected abstract void _releaseBuffers()
Method called to release any buffers generator may be holding, once generator is being closed.

### _verifyValueWrite

protected abstract void _verifyValueWrite(String typeMsg) throws IOException
Method called before trying to write a value (scalar or structured), to verify that this is legal in current output state, as well as to output separators if and as necessary.

Parameters:
  `typeMsg` - Additional message used for generating exception message if value output is NOT legal in current generator output state.
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### _constructDefaultPrettyPrinter

protected PrettyPrinter _constructDefaultPrettyPrinter()
Overridable factory method called to instantiate an appropriate `PrettyPrinter` for case of "just use the default one", when `useDefaultPrettyPrinter()` is called.

Returns:
  Instance of "default" pretty printer to use
Since:
  2.6

### _asString

protected String _asString(BigDecimal value) throws IOException
Helper method used to serialize a `BigDecimal` as a String, for serialization, taking into account configuration settings

Parameters:
  `value` - BigDecimal value to convert to String
Returns:
  String representation of `value`
Throws:
  `IOException` - if there is a problem serializing value as String
Since:
  2.7.7

### _decodeSurrogate

protected final int _decodeSurrogate(int surr1, int surr2) throws IOException

Throws:
  `IOException`

### _checkRangeBoundsForByteArray

protected void _checkRangeBoundsForByteArray(byte[] data, int offset, int len) throws IOException

Throws:
  `IOException`

### _checkRangeBoundsForCharArray

protected void _checkRangeBoundsForCharArray(char[] data, int offset, int len) throws IOException

Throws:
  `IOException`

### _checkRangeBoundsForString

protected void _checkRangeBoundsForString(String data, int offset, int len) throws IOException

Throws:
  `IOException`